// Persistence Of Vision raytracer version 3.0

#version 3.0
global_settings { assumed_gamma 2.2 }

#include "colors.inc"
#include "textures.inc"

camera {
    location <0, 0, -85>
    right <4/3, 0.0, 0.0>
    direction 2*z
    look_at <0, 0, 0>
}

light_source { <10, 15, -30> color rgb<clock,clock,clock> area_light <3,0,0>,<0,0,3>,3,3 adaptive 1 jitter}
light_source { <15, -10, -15 > color rgb<clock,clock,clock> area_light <3,0,0>,<0,0,3>,3,3 adaptive 1 jitter}
light_source { <-15, -10, -15> color rgb<clock,clock,clock> area_light <3,0,0>,<0,0,3>,3,3 adaptive 1 jitter}

#declare CubeSide = box { <2, 0, 2> , <12, -0.2, 12> }

#declare One = polygon { 11, <3,0,10>,<3,0,6>,<9,0,6>,<9,0,4>,<11,0,4>,
                             <11,0,10>,<9,0,10>,<9,0,8>,<5,0,8>,<5,0,10>,
                             <3,0,10>
                             pigment { color Blue }
                        }
#declare Two = polygon { 13, <4,0,11>,<4,0,6>,<8,0,6>,<8,0,5>,<4,0,5>
                             <4,0,3>,<10,0,3>,<10,0,8>,<6,0,8>,<6,0,9>
                             <10,0,9>,<10,0,11>,<4,0,11>
                             pigment { color Green }
                        }
#declare Five = polygon { 13, <4,0,11>,<4,0,9>,<8,0,9>,<8,0,8>,<4,0,8>
                              <4,0,3>,<10,0,3>,<10,0,5>,<6,0,5>,<6,0,6>
                              <10,0,6>,<10,0,11,>,<4,0,11>
                              pigment { color Yellow }
                        }
#declare Six = polygon { 14, <3,0,10>,<3,0,4>,<11,0,4>,<11,0,10>,<9,0,10>
                             <9,0,6>,<8,0,6>,<8,0,10>,<3,0,10>
                             <5,0,8>,<5,0,6>,<6,0,6>,<6,0,8>,<5,0,8>
                             pigment { color Cyan }
                       }
#declare Three = polygon { 13, <3,0,10>,<3,0,4>,<11,0,4>,<11,0,10>,<9,0,10>
                               <9,0,6>,<8,0,6>,<8,0,10>,<6,0,10>,<6,0,6>
                               <5,0,6>,<5,0,10>,<3,0,10>
                               pigment {color Red }
                         }
#declare Four = union { polygon { 10, <2.5,0,6.5>,<3,0,6>,<4,0,7>,<3,0,7>,<2.5,0,6.5>
                                      <4,0,8>,<5,0,8>,<7,0,10>,<7,0,11>,<4,0,8>
                                      pigment { color Yellow }
                                }
                        polygon { 5, <3,0,6>,<10,0,6>,<10,0,7>,<4,0,7>,<3,0,6>
                                     pigment { color Red }
                                }
                        polygon { 10, <7,0,6>,<7,0,4>,<8,0,4>,<8,0,6>,<7,0,6>
                                      <7,0,11>,<7,0,7>,<8,0,7>,<8,0,11>,<7,0,11>
                                      pigment { color Green }
                                }
                        polygon { 10, <10,0,7>,<10,0,5>,<11,0,5>,<11,0,7>,<10,0,7>
                                      <10,0,9>,<10,0,8>,<11,0,8>,<11,0,9>,<10,0,9>
                                      pigment { color Magenta }
                                }
                        polygon { 10, <4,0,8>,<3,0,7>,<7,0,7>,<7,0,8>,<4,0,8>
                                      <8,0,8>,<8,0,7>,<11,0,7>,<11,0,8>,<8,0,8>
                                      pigment { color Blue }
                                }
                       }
object {
union {
union { object { CubeSide
      texture { pigment { Magenta } finish {Shiny} } }
      object { Six translate <0, 0.2, 0> }
      object { Six translate <0, -0.4, 0> }
      translate <7, 0, -7 >
     }
union { object { CubeSide
      texture { pigment { Yellow } finish {Shiny} } }
      object { Three translate <0, 0.2, 0> }
      object { Three translate <0, -0.4, 0> }
      translate <21, 0, -7 >
     }
union { object { CubeSide
      texture { pigment { Blue } finish {Shiny} } translate <0,0,-14>}
      object { Two translate <0, 0.2, -14> }
      object { Two translate <0, -0.4, -14> }
      translate <-7, 0, -7 >
     }
union { object { CubeSide
      texture { pigment { Red } finish {Shiny} } }
      object { Five translate <0, 0.2, 0> }
      object { Five translate <0, -0.4, 0> }
      translate <-7, 0, 7 >
     }
union { object { CubeSide
      texture { pigment { Green } finish {Shiny} } translate <-14,0,0> }
      object { One translate <-14, 0.2, 0> }
      object { One translate <-14, -0.4, 0> }
      translate <-7, 0, -7 >
     }
union { object { CubeSide
      texture { pigment { Gray50 } finish {Shiny} } }
      object { Four translate <0, -0.4, 0> }
      translate <-7, 0, -7 >
     }
     }
     rotate < 0, 0, 0 >
     translate < 0, 0, 0 >
}
